=== debian/changelog ===
86box (4.1.1) UNRELEASED; urgency=medium

  * Bump release.

 -- Jasmine Iwanek <jriwanek@gmail.com>  Fri, 23 Feb 2024 07:23:12 +0100
